"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sourceNodes = sourceNodes;
exports.onCreateNode = onCreateNode;

var _crypto = _interopRequireDefault(require("crypto"));

var _gatsbySourceFilesystem = require("gatsby-source-filesystem");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function sourceNodes({
  actions,
  createNodeId
}, options) {
  delete options.plugins;

  if (!Array.isArray(options.files)) {
    return;
  }

  const createNode = actions.createNode;
  options.files.forEach(file => {
    if (!file.name || !file.url) {
      throw new Error('All file must contain a "name" and an "url" property');
    }

    const nodeId = createNodeId(`remotefile-${file.name}`);
    const nodeContent = JSON.stringify(file);

    const nodeContentDigest = _crypto.default.createHash("md5").update(nodeContent).digest("hex");

    const nodeData = _objectSpread({}, file, {
      id: nodeId,
      parent: null,
      children: [],
      internal: {
        type: "RemoteFile",
        content: nodeContent,
        contentDigest: nodeContentDigest
      }
    });

    createNode(nodeData);
  });
}

function onCreateNode(_x) {
  return _onCreateNode.apply(this, arguments);
}

function _onCreateNode() {
  _onCreateNode = _asyncToGenerator(function* ({
    node,
    actions,
    store,
    cache
  }) {
    if (node.internal.type !== "RemoteFile") {
      return;
    }

    const createNode = actions.createNode;
    const fileNode = yield (0, _gatsbySourceFilesystem.createRemoteFileNode)({
      url: node.url,
      store,
      cache,
      createNode,
      createNodeId: id => `downloaded-remotefile-${id}`
    });

    if (fileNode) {
      node.file___NODE = fileNode.id;
    }
  });
  return _onCreateNode.apply(this, arguments);
}